package xyz.lychee.lagfixer.libs.adventure.text.format;

import java.util.EnumMap;
import java.util.Map;
import xyz.lychee.lagfixer.libs.adventure.key.Key;
import xyz.lychee.lagfixer.libs.adventure.text.event.ClickEvent;
import xyz.lychee.lagfixer.libs.adventure.text.event.HoverEvent;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.annotations.Unmodifiable;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.NonExtendable;

@NonExtendable
public interface StyleGetter {
   @Nullable Key font();

   @Nullable TextColor color();

   default boolean hasDecoration(final @NotNull TextDecoration decoration) {
      return this.decoration(decoration) == TextDecoration.State.TRUE;
   }

   TextDecoration.@NotNull State decoration(final @NotNull TextDecoration decoration);

   default @Unmodifiable @NotNull Map<TextDecoration, TextDecoration.State> decorations() {
      Map<TextDecoration, TextDecoration.State> decorations = new EnumMap(TextDecoration.class);
      int i = 0;

      for(int length = DecorationMap.DECORATIONS.length; i < length; ++i) {
         TextDecoration decoration = DecorationMap.DECORATIONS[i];
         TextDecoration.State value = this.decoration(decoration);
         decorations.put(decoration, value);
      }

      return decorations;
   }

   @Nullable ClickEvent clickEvent();

   @Nullable HoverEvent<?> hoverEvent();

   @Nullable String insertion();
}
